Bug 907756 - Review Request: cloud-utils - cloud image management utilities
Summary: Review Request: cloud-utils - cloud image management utilities
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Pádraig Brady
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2013-02-05 08:01 UTC by Juerg Haefliger
Modified: 2014-02-17 14:58 UTC (History)
11 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2013-03-06 22:59:58 UTC
p: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Juerg Haefliger 2013-02-05 08:01:46 UTC
Spec URL: http://juergh.fedorapeople.org/review/cloud-utils/cloud-utils.spec
SRPM URL: http://juergh.fedorapeople.org/review/cloud-utils/cloud-utils-0.27-0.1.bzr216.fc19.src.rpm

Description:
This package provides a useful set of utilities for managing cloud images. The euca2ools package (a dependency of cloud-utils) provides an Amazon EC2 API compatible set of utilities for bundling kernels, ramdisks, and root filesystems, and uploading them to either EC2 or UEC. The tasks associated with image bundling are often tedious and repetitive. The cloud-utils package provides several scripts that wrap the complicated tasks with a much simpler interface.

Fedora Account System Username: juergh
Scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=4929458

This is my first package and I need a sponsor.

Comment 1 Matthias Runge 2013-02-05 09:24:38 UTC
some drive by comments:

- there's no need to define a buildroot, please drop that

- please remove 
rm -rf $RPM_BUILD_ROOT
 from the beginning of install section

- please remove the clean section

- please remove that defattr line from files section

Taken from debian/copyright:
 The complete text of the GPL version 3 can be seen in
 /usr/share/common-licenses/GPL-3.

There is no such file at Fedora.

From that file:
This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

Well, I'm not a copyright expert. So I can not say, if it's acceptable to say, something is GPL3 licensed and then also to change that license by adding more clauses.

Comment 2 Matthias Runge 2013-02-05 09:27:00 UTC
Also, why do you use a bzr export. There are tarballs available, e.g.
https://launchpad.net/cloud-utils/trunk/0.26/+download/cloud-utils-0.26.tar.gz

Comment 3 Pádraig Brady 2013-02-05 13:15:40 UTC
Requires: s/util-linux-ng/util-linux/
Also I noticed one of the scripts needs to Require: qemu-img

Comment 4 Juerg Haefliger 2013-02-05 14:31:02 UTC
(In reply to comment #1)
> some drive by comments:
> 
> - there's no need to define a buildroot, please drop that
> 
> - please remove 
> rm -rf $RPM_BUILD_ROOT
>  from the beginning of install section
> 
> - please remove the clean section
> 
> - please remove that defattr line from files section
> 
> Taken from debian/copyright:
>  The complete text of the GPL version 3 can be seen in
>  /usr/share/common-licenses/GPL-3.
> 
> There is no such file at Fedora.
> 
> From that file:
> This program is distributed in the hope that it will be useful,
>  but WITHOUT ANY WARRANTY; without even the implied warranty of
>  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
>  GNU General Public License for more details.
> 
> Well, I'm not a copyright expert. So I can not say, if it's acceptable to
> say, something is GPL3 licensed and then also to change that license by
> adding more clauses.

Thanks, will take care of those and talk to upstream regarding the licensing.

Comment 5 Juerg Haefliger 2013-02-05 14:32:06 UTC
(In reply to comment #2)
> Also, why do you use a bzr export. There are tarballs available, e.g.
> https://launchpad.net/cloud-utils/trunk/0.26/+download/cloud-utils-0.26.tar.
> gz

Because I need tip of trunk and not some old (released) version. I just copied what the cloud-init packager did.

Comment 6 Juerg Haefliger 2013-02-06 10:28:11 UTC
(In reply to comment #1)
> Taken from debian/copyright:
>  The complete text of the GPL version 3 can be seen in
>  /usr/share/common-licenses/GPL-3.
> 
> There is no such file at Fedora.

OK. I add a dedicated GPL3 license file.
 
> From that file:
> This program is distributed in the hope that it will be useful,
>  but WITHOUT ANY WARRANTY; without even the implied warranty of
>  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
>  GNU General Public License for more details.
> 
> Well, I'm not a copyright expert. So I can not say, if it's acceptable to
> say, something is GPL3 licensed and then also to change that license by
> adding more clauses.

It seems to be common to add this text. It's in a lot of license files in Ubuntu so I'm assuming it's OK (legally).

Comment 7 Pádraig Brady 2013-02-06 10:36:22 UTC
I also notice *ubuntu* scripts, which probably should be excluded from the install

Comment 8 Matthias Runge 2013-02-06 13:16:32 UTC
(In reply to comment #6)
> It seems to be common to add this text. It's in a lot of license files in
> Ubuntu so I'm assuming it's OK (legally).

That may legally ok for Ubuntu (maybe nobody took this to court), but I'd like to ask our legal department regarding this.

@FE-Legal:
So, the question here is: is it ok to use GPLv3 and add the following text:

#
#    Copyright (C) 2010 Canonical Ltd.
#
#    Authors: Scott Moser <smoser@canonical.com>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, version 3 of the License.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

(taken from e.g. http://bazaar.launchpad.net/~cloud-utils-dev/cloud-utils/trunk/view/head:/bin/cloud-publish-image )

This should be still GPLv3, right?



I'm not saying, this software is non-free software.

Regarding those Ubuntu targeted scripts, I asked myself: what value would be added to Fedora? As far as I can see, there would be some scripts added, to interact with Ubuntu Cloud services and to solely manage Ubuntu cloud images, right? 

Do the tools also work for Fedora images at e.g. Amazon Cloud?

Comment 9 Tom "spot" Callaway 2013-02-06 16:16:04 UTC
This method and wording of attribution for GPLv3 is word-for-word how the GPLv3 license text advises you to do it.

See: "How to Apply These Terms to Your New Programs" in
http://www.gnu.org/licenses/gpl-3.0.txt

Lifting FE-Legal

Comment 10 Sandro Mathys 2013-02-11 10:39:53 UTC
(In reply to comment #1)
> some drive by comments:
> 
> - there's no need to define a buildroot, please drop that
> 
> - please remove 
> rm -rf $RPM_BUILD_ROOT
>  from the beginning of install section
> 
> - please remove the clean section

What repos do you plan to submit this package for? While the above is necessary for Fedora and EPEL 6, it would break compatibility to EPEL 5. Just saying. :)

Comment 11 Juerg Haefliger 2013-02-11 12:40:37 UTC
> What repos do you plan to submit this package for? While the above is
> necessary for Fedora and EPEL 6, it would break compatibility to EPEL 5.
> Just saying. :)

Fedora and EPEL 6.

Comment 12 Juerg Haefliger 2013-02-11 12:54:43 UTC
(In reply to comment #8)
> (In reply to comment #6)
> Regarding those Ubuntu targeted scripts, I asked myself: what value would be
> added to Fedora? As far as I can see, there would be some scripts added, to
> interact with Ubuntu Cloud services and to solely manage Ubuntu cloud
> images, right? 

Some of the scripts are Ubuntu-specific for importing images into EC2, launching instances and finding the latest Ubuntu AMIs.
 
> Do the tools also work for Fedora images at e.g. Amazon Cloud?

Not the ones mentioned above. Easiest would be to just exclude those for now. If there are requests for similar functionality later we can address them then.

Comment 13 Juerg Haefliger 2013-02-12 14:35:20 UTC
Changes per reviewers comments and requests.

Spec URL: http://juergh.fedorapeople.org/review/cloud-utils-0.27-0.2.bzr216.fc19/cloud-utils.spec
SRPM URL: http://juergh.fedorapeople.org/review/cloud-utils-0.27-0.2.bzr216.fc19/cloud-utils-0.27-0.2.bzr216.fc19.src.rpm
Scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=4952868


Spec file diff:

diff --git a/cloud-utils.spec b/cloud-utils.spec
index dbdedb7..567c18c 100644
--- a/cloud-utils.spec
+++ b/cloud-utils.spec
@@ -1,16 +1,16 @@
 Summary:       Cloud image management utilities
 Name:          cloud-utils
 Version:       0.27
-Release:       0.1.bzr216%{?dist}
+Release:       0.2.bzr216%{?dist}
 License:       GPLv3
 Group:         System Environment/Base
 URL:           https://launchpad.net/cloud-utils
 
 # bzr export -r 216 cloud-utils-0.27-bzr216.tar.gz lp:cloud-utils
 Source0:       %{name}-%{version}-bzr216.tar.gz
+Source1:        LICENSE
 
 BuildArch:     noarch
-BuildRoot:     %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
 
 Requires:      gawk
 Requires:      gdisk
@@ -19,7 +19,8 @@ Requires:     euca2ools
 Requires:      file
 Requires:      python
 Requires:      python-paramiko
-Requires:      util-linux-ng
+Requires:      qemu-img
+Requires:      util-linux
 
 %description
 This package provides a useful set of utilities for managing cloud images.
@@ -32,31 +33,39 @@ The tasks associated with image bundling are often tedious and repetitive. The
 cloud-utils package provides several scripts that wrap the complicated tasks
 with a much simpler interface.
 
+
 %prep
 %setup -q -n %{name}-%{version}-bzr216
 
+
 %build
 
+
 %install
-rm -rf $RPM_BUILD_ROOT
+cp %{SOURCE1} LICENSE
 
 # Install binaries
 mkdir -p $RPM_BUILD_ROOT/%{_bindir}
 cp bin/* $RPM_BUILD_ROOT/%{_bindir}/
+# Exclude Ubuntu-specific tools
+rm $RPM_BUILD_ROOT/%{_bindir}/*ubuntu*
 
 # Install man pages
 mkdir -p $RPM_BUILD_ROOT/%{_mandir}/man1
 cp man/* $RPM_BUILD_ROOT/%{_mandir}/man1/
 
-%clean
-rm -rf $RPM_BUILD_ROOT
 
 %files
-%defattr(-,root,root,-)
-%doc ChangeLog debian/copyright
+%doc ChangeLog LICENSE
 %{_bindir}/*
 %doc %{_mandir}/man1/*
 
+
 %changelog
+* Wed Feb 12 2013 Juerg Haefliger <juergh@gmail.com> - 0.27-0.2.bzr216
+- Add GPL-3 license.
+- Exclude Ubuntu-specific tools.
+- Fix some spec file issues per reviewers comments.
+
 * Tue Feb  5 2013 Juerg Haefliger <juergh@gmail.com> - 0.27-0.1.bzr216
 - Initial build based on upstream revision bzr216.

Comment 14 Pádraig Brady 2013-02-13 15:32:13 UTC
Could you clarify comment #5
I'll note ubuntu raring is using v 0.26
Do we really need an unreleased trunk version?
Note cloud-init rawhide is using 0.7.1 release

Comment 15 Pádraig Brady 2013-02-13 15:44:44 UTC
Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- License field in the package spec file matches the actual license.
  Note: Checking patched sources after %prep for licenses. No licenses found.

(To fix this you would do the cp LICENCE in the %prep section)


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package complies to the Packaging Guidelines
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 40960 bytes in 2 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
[x]: Spec file lacks Packager, Vendor, PreReq tags.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

===== SHOULD items =====

Generic:
[!]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[!]: Package does not include license text files separate from upstream.
[x]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[-]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: cloud-utils-0.27-0.2.bzr216.fc15.noarch.rpm
cloud-utils.noarch: W: spelling-error %description -l en_US ramdisks -> ram disks, ram-disks, radiograms
cloud-utils.noarch: W: spelling-error %description -l en_US filesystems -> file systems, file-systems, systematizes
cloud-utils.noarch: W: no-manual-page-for-binary ec2metadata
cloud-utils.noarch: W: no-manual-page-for-binary cloud-localds
1 packages and 0 specfiles checked; 0 errors, 4 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint cloud-utils
cloud-utils.noarch: I: enchant-dictionary-not-found en_US
cloud-utils.noarch: W: no-manual-page-for-binary ec2metadata
cloud-utils.noarch: W: no-manual-page-for-binary cloud-localds
1 packages and 0 specfiles checked; 0 errors, 2 warnings.
# echo 'rpmlint-done:'



Requires
--------
cloud-utils (rpmlib, GLIBC filtered):
    /bin/bash
    /bin/sh
    /usr/bin/python
    e2fsprogs
    euca2ools
    file
    gawk
    gdisk
    python
    python-paramiko
    qemu-img
    util-linux



Provides
--------
cloud-utils:
    cloud-utils

Generated by fedora-review 0.4.0 (660ce56) last change: 2013-01-29
Buildroot used: fedora-15-x86_64
Command line :/usr/bin/fedora-review -b 907756

Comment 16 Pádraig Brady 2013-02-13 16:53:36 UTC
Summary of comment 15 is that package is OK :)
Question in comment 14 still stands.

Comment 17 Juerg Haefliger 2013-02-14 10:08:59 UTC
(In reply to comment #14)
> Could you clarify comment #5
> I'll note ubuntu raring is using v 0.26
> Do we really need an unreleased trunk version?

Yes. growroot in 0.26 doesn't support GPT partition tables (which I added in upstream). I can ask upstream to cut a new release but that might take a while.

Comment 18 Juerg Haefliger 2013-02-14 10:13:56 UTC
(In reply to comment #17)
> (In reply to comment #14)
> > Could you clarify comment #5
> > I'll note ubuntu raring is using v 0.26
> > Do we really need an unreleased trunk version?
> 
> Yes. growroot in 0.26 doesn't support GPT partition tables (which I added in
> upstream). I can ask upstream to cut a new release but that might take a
> while.

s/growroot/growpart/

Comment 19 Pádraig Brady 2013-02-14 11:31:46 UTC
Ok cool,

You're free to add the SCM request to this bug,
after you get sponsored.

Matthias can you handle that?

thanks!

Comment 20 Matthias Runge 2013-02-14 11:39:05 UTC
Juerg, I'll sponsor you into packager group. Pádraigs looks good to me.

Matthias

Comment 21 Juerg Haefliger 2013-02-18 12:18:22 UTC
New Package SCM Request
=======================
Package Name: cloud-utils
Short Description: Cloud image management utilities
Owners: juergh
Branches: f19 el6
InitialCC:

Comment 22 Pádraig Brady 2013-02-18 13:06:57 UTC
Note f19 is not branched yet, and also this would be good for f18 too.
So I'd add another comment request with s/f19/f18/. thanks

Comment 23 Matthias Runge 2013-02-18 13:13:53 UTC
Yeah, good point, Pádraig.

New Package SCM Request
=======================
Package Name: cloud-utils
Short Description: Cloud image management utilities
Owners: juergh
Branches: f18 f19 el6
InitialCC:

Comment 24 Gwyn Ciesla 2013-02-18 14:46:03 UTC
Git done (by process-git-requests).

Comment 25 Fedora Update System 2013-02-20 09:14:56 UTC
cloud-utils-0.27-0.2.bzr216.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/cloud-utils-0.27-0.2.bzr216.fc18

Comment 26 Fedora Update System 2013-02-21 05:46:16 UTC
cloud-utils-0.27-0.2.bzr216.fc18 has been pushed to the Fedora 18 testing repository.

Comment 27 Fedora Update System 2013-03-06 23:00:00 UTC
cloud-utils-0.27-0.2.bzr216.fc18 has been pushed to the Fedora 18 stable repository.

Comment 28 Fedora Update System 2013-03-14 08:37:18 UTC
cloud-utils-0.27-0.2.bzr216.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/cloud-utils-0.27-0.2.bzr216.el6

Comment 29 Scott Moser 2013-03-28 12:12:02 UTC
fwiw, i just released cloud-utils 0.27 yesterday.
https://launchpad.net/cloud-utils/trunk/0.27

Comment 30 Jack Lysaght 2013-03-28 12:31:51 UTC
Regardless of whether it can access RHEL/Fedora resources on AWS, this tool is valuable as a resource for inclusion. It gives AWS querying ability that is far better than anything else available for AWS AMIs. 

If other AMI providers provided a tool such as this finding an AMI would be a cinch instead of rage-inducing.

Comment 31 Fedora Update System 2013-04-09 09:50:06 UTC
cloud-utils-0.27-3.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/cloud-utils-0.27-3.fc19

Comment 32 Fedora Update System 2013-04-09 09:58:04 UTC
cloud-utils-0.27-3.el6 has been submitted as an update for Fedora EPEL 6.
https://admin.fedoraproject.org/updates/cloud-utils-0.27-3.el6

Comment 33 Fedora Update System 2013-04-25 14:19:09 UTC
cloud-utils-0.27-3.fc19 has been pushed to the Fedora 19 stable repository.

Comment 34 Fedora Update System 2013-04-29 17:52:50 UTC
cloud-utils-0.27-3.el6 has been pushed to the Fedora EPEL 6 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 35 Juerg Haefliger 2014-02-17 12:13:29 UTC
Package Change Request
======================
Package Name: cloud-utils
New Branches: epel7
Owners: juergh

Comment 36 Sandro Mathys 2014-02-17 13:26:12 UTC
Juerg, you'll also need to change the fedora-cvs flag to ? to get the necessary attention. But as described in [1], usage of [2] for epel7 requests is preferred (but not mandatory).

[1] https://fedoraproject.org/wiki/EPEL/epel7beta-faq
[2] https://fedoraproject.org/wiki/EPEL/epel7/Requests

Comment 37 Gwyn Ciesla 2014-02-17 14:58:14 UTC
Git done (by process-git-requests).


Note You need to log in before you can comment on or make changes to this bug.